Qore Programming Language Reference Manual: Qore::HashListReverseIterator Class Reference

Qore Programming Language Reference Manual 0.8.11

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | List of all members
Qore::HashListReverseIterator Class Reference

This class a reverse iterator class for hashes of lists as returned by Qore::SQL::Datasource::select() and Qore::SQL::DatasourcePool::select(), both of which return hashes with keys giving column names where the key values are lists of column values. More...

Inheritance diagram for Qore::HashListReverseIterator:
[legend]

## Public Member Functions
| constructor (hash h)
| Creates the hash list iterator object. More...
| constructor ()
| Creates an empty hash list iterator object. More...
| copy ()
| Creates a copy of the HashListReverseIterator object, iterating the same object as the original and in the same position. More...
bool | first ()
| returns True if on the first element being iterated in the list (ie the last element in the list) More...
bool | last ()
| returns True if on the last element being iterated in the list (ie the first element in the list) More...
any | memberGate (string key)
| This method allows the iterator to be dereferenced directly as a hash for the current row being iterated, as memberGate methods are called implicitly when an unknown member is accessed from outside the class. More...
bool | next ()
| Moves the current position to the next element in the result list; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the list if the list is not empty. More...
bool | prev ()
| Moves the current position to the previous element in the result list; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the list if the list is not empty. More...
Public Member Functions inherited from Qore::HashListIterator
| constructor (hash h)
| Creates the hash list iterator object. More...
| constructor ()
| Creates an empty hash list iterator object. More...
| copy ()
| Creates a copy of the HashListIterator object, iterating the same object as the original and in the same position. More...
bool | empty ()
| returns True if the result list is empty; False if not More...
any | getKeyValue (string key)
| Returns the current value for the column given as an argument. More...
hash | getRow ()
| returns the current row value as a hash or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
hash | getValue ()
| returns the current row value as a hash or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
int | index ()
| returns the current iterator position in the list or -1 if not pointing at a valid element More...
int | max ()
| returns the number of elements in the list More...
any | memberGate (string key)
| This method allows the iterator to be dereferenced directly as a hash for the current row being iterated, as memberGate methods are called implicitly when an unknown member is accessed from outside the class. More...
| reset ()
| Reset the iterator instance to its initial state. More...
bool | set (int pos)
| sets the new position in the result list; if the position is invalid then the method returns False, meaning the iterator is not valid, otherwise it returns True More...
bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not More...

## Detailed Description

This class a reverse iterator class for hashes of lists as returned by Qore::SQL::Datasource::select() and Qore::SQL::DatasourcePool::select(), both of which return hashes with keys giving column names where the key values are lists of column values.

Like the Qore::HashListIterator class, this class can be used as a more flexible alternative to the context statement, except this class will iterate the result list in reverse order.

Call HashListReverseIterator::next() to iterate through the lists of column values assigned to each hash key in reverse order; do not use the iterator if HashListReverseIterator::next() returns False. A result list can be iterated in reverse order by calling HashListReverseIterator::prev() instead of HashListReverseIterator::next()

Example: HashListReverseIterator basic usge
  my hash $data = ( "column1" : ( 1, 2, 3, ),
  "column2" : ( "a", "b", "c", ) );
  my HashListReverseIterator $it($data);
  while ($it.next()) {
  printf("iter %d: getValue: %n; getKeyValue('column1'): %n\n",
  $it.index(), $it.getValue(), $it.getKeyValue('column1'));
  }
  iter 2: getValue: hash: (column1 : 3, column2 : "c"); getKeyValue('column1'): 3
  iter 1: getValue: hash: (column1 : 2, column2 : "b"); getKeyValue('column1'): 2
  iter 0: getValue: hash: (column1 : 1, column2 : "a"); getKeyValue('column1'): 1

Note
  - In general, the HashListReverseIterator class is not designed to be accessed from multiple threads; it was created without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause an `ITERATOR-THREAD-ERROR` to be thrown.
  - HashListReverseIterator is functionally equivalent to HashListIterator, but the effect of HashListReverseIterator::next() and HashListReverseIterator::prev() are the opposite of HashListIterator::next() and HashListIterator::prev(); that is HashListReverseIterator::next() will iterate through the hash in reverse order, while HashListReverseIterator::prev() iterates in forward order. Additionally the meanings of the return values for HashListReverseIterator::first() and HashListReverseIterator::last() are swapped in respect to HashListIterator::first() and HashListIterator::last().

See Also
  HashListIterator

## Member Function Documentation

Qore::HashListReverseIterator::constructor | ( | hash | h | ) |

Creates the hash list iterator object.

Parameters

  h | the hash of lists to iterate

Example:
  my HashListReverseIterator $i($h);

Qore::HashListReverseIterator::constructor | ( |  | ) |

Creates an empty hash list iterator object.

Example:
  my *hash $q = $ds.select("select * from some_table");
  my HashListReverseIterator $i($q);

Qore::HashListReverseIterator::copy | ( |  | ) |

Creates a copy of the HashListReverseIterator object, iterating the same object as the original and in the same position.

Example:
  my HashListReverseIterator $ni = $i.copy();

bool Qore::HashListReverseIterator::first | ( |  | ) |
| virtual

returns True if on the first element being iterated in the list (ie the last element in the list)

Returns
  True if on the first element being iterated in the list (ie the last element in the list)

Code Flags:
  CONSTANT

Example:
  while ($i.next()) {
  if ($i.first())
  printf("START:\n");
  }

Reimplemented from Qore::HashListIterator.

bool Qore::HashListReverseIterator::last | ( |  | ) |
| virtual

returns True if on the last element being iterated in the list (ie the first element in the list)

Returns
  True if on the last element being iterated in the list (ie the first element in the list)

Code Flags:
  CONSTANT

Example:
  while ($i.next()) {
  if ($i.last())
  printf("END.\n");
  }

Reimplemented from Qore::HashListIterator.

any Qore::HashListReverseIterator::memberGate | ( | string | key | ) |

This method allows the iterator to be dereferenced directly as a hash for the current row being iterated, as memberGate methods are called implicitly when an unknown member is accessed from outside the class.

Code Flags:
  RET_VALUE_ONLY

Parameters

  key | the column name for the value to retrieve

Returns
  the current column value of the given row

Example:
  while ($i.next()) {
  printf("%d: value: %y", $i.index(), $i.value);
  }

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object
  INVALID-ITERATOR | the iterator is not pointing at a valid element
  HASHLISTITERATOR-ERROR | the hash key given has a value that is not a list

Note
  equivalent to HashListIterator::getKeyValue() when called explicitly

bool Qore::HashListReverseIterator::next | ( |  | ) |
| virtual

Moves the current position to the next element in the result list; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the list if the list is not empty.

This method will return True again after it returns False once if list is not empty, otherwise it will always return False. The iterator object should not be used after this method returns False

Returns
  False if there are no more elements in the result list (in which case the iterator object is invalid and should not be used); True if successful (meaning that the iterator object is valid)

Example:
  while ($i.next()) {
  printf(" + row %d: %y\n", $i.index(), $i.getValue());
  }

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Reimplemented from Qore::HashListIterator.

bool Qore::HashListReverseIterator::prev | ( |  | ) |
| virtual

Moves the current position to the previous element in the result list; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the list if the list is not empty.

This method will return True again after it returns False once if the list is not empty, otherwise it will always return False. The iterator object should not be used after this method returns False

Returns
  False if there are no more elements in the result list (in which case the iterator object is invalid and should not be used); True if successful (meaning that the iterator object is valid)

Example:
  while ($i.prev()) {
  printf(" + row %d: %y\n", $i.index(), $i.getValue());
  }

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Reimplemented from Qore::HashListIterator.